//$ bin/sjc tests/src/quickstart/Alice.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ quickstart.Alice

package quickstart;

import sj.runtime.*;
import sj.runtime.net.*;

class Alice {
	public static void main(String[] args) throws Exception
	{
		protocol AliceToBob { begin.!<String>.?(String) }
	
		SJServerSocket ss = null;
	
		try	{
			ss = SJFServerSocket.create(AliceToBob, 1234);			
			SJSocket s = null;
			
			try (s) {
				s = ss.accept();
				s.send("Hello Bob from Alice!");				
				System.out.println((String) s.receive());
			}
			finally {
			
			}
		}
		finally {
			if (ss != null) ss.close();
		}		
	}
} 
