// bin/sjc tests/src/runtime/fsocket/delegation/case4/B.sj -d tests/classes/
// bin/sj -cp tests/classes/ runtime.fsocket.delegation.case4.B HZHL 8888 9999

package runtime.fsocket.delegation.case4;

import sj.runtime.*;
import sj.runtime.net.*;

class B
{
	public static void main(String[] args) throws Exception 
	{
		protocol body { ?(String).?(String) }
		protocol p_a { begin.@body }
		protocol p_c { begin.!<@body> }		
		
		SJServerSocket ss = null;

		try
		{
			ss = SJFServerSocket.create(p_a, Integer.parseInt(args[2]));
		
			SJServerAddress c_c = SJServerAddress.create(p_c, args[0], Integer.parseInt(args[1]));
			SJSocket s_c = SJFSocket.create(c_c);
	
			SJSocket s_a = null;
	
			try (s_c, s_a)
			{
				s_c.request();
				
				s_a = ss.accept();
				
				s_c.send(s_a);
			}
			finally
			{

			}
		}
		finally
		{
			if (ss != null) ss.close();
		}
	}
}
