// bin/sjc tests/src/runtime/fsocket/delegation/case4/D.sj -d tests/classes/
// bin/sj -cp tests/classes/ runtime.fsocket.delegation.case4.D 7777

package runtime.fsocket.delegation.case4;

import java.io.IOException;

import sj.runtime.*;
import sj.runtime.net.*;

class D 
{
	public static void main(String[] args) throws Exception 
	{
		protocol p_c { !<String> }
		protocol p_a { begin.?(@p_c) }

		SJServerSocket ss = null;
		
		try
		{
			ss = SJFServerSocket.create(p_a, Integer.parseInt(args[0]));
		
			SJSocket s_a = null;		
			SJSocket s_c = null;

			try (s_a, s_c)
			{
				s_a = ss.accept();
				
				s_c = (@p_c) s_a.receive();
				
				s_c.send("Hello from D!");
			}
			finally
			{
			
			}
		}
		finally
		{
			if (ss != null) ss.close();
		}
	}
}
