// bin/sjc tests/src/runtime/rsocket/delegation/case1/A.sj -d tests/classes/
// bin/sj -cp tests/classes runtime.rsocket.delegation.case1.A HZHL 8888

package runtime.fsocket.delegation.case1;

import java.io.*;

import sj.runtime.*;
import sj.runtime.net.*;

class A 
{
	//BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
	//try { br.readLine(); } catch(IOException ioe) { }

	public static void main(String[] args) throws Exception 
	{
		protocol p_b { begin.!<int>.?(int) }

		SJServerAddress c_b = SJServerAddress.create(p_b, args[0], Integer.parseInt(args[1]));
		SJSocket s_b = SJRSocket.create(c_b);
		
		try (s_b)
		{
			s_b.request();
			
			int i = 0;

			s_b.send(123);
		
			System.out.println("Received: " + s_b.receiveInt());
		}
		finally
		{
		
		}
	}
}
