// bin/sjc tests/src/runtime/rsocket/delegation/case1/B.sj -d tests/classes/
// bin/sj -cp tests/classes/ runtime.rsocket.delegation.case1.B 8888 HZHL 9999

package runtime.fsocket.delegation.case1;

import java.io.*;

import sj.runtime.*;
import sj.runtime.net.*;

class B 
{
	public static void main(String[] args) throws Exception 
	{
		protocol body { ?(int).!<int> }
		protocol p_a { begin.@body }
		protocol p_c { begin.!<@body> }

		SJServerSocket ss = null;

		try
		{
			ss = SJRServerSocket.create(p_a, Integer.parseInt(args[0]));
			
			SJSocket s_a = null;

			SJServerAddress c_c  = SJServerAddress.create(p_c, args[1], Integer.parseInt(args[2]));
			SJSocket s_c = SJRSocket.create(c_c);

			try (s_a, s_c)
			{
				s_a = ss.accept();
				
				s_c.request();		
				
				s_c.send(s_a);
			}
			finally 
			{

			}				
		}
		finally 
		{
			if (ss != null) ss.close();
		}
	}
}
