//$ bin/sjc tests/src/Test.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ Test

import java.util.*;

import sj.runtime.*;
import sj.runtime.net.*;

public class Test 
{
	public Test(String server, int port) throws Exception
	{			
		protocol p { begin.!<String> }
		
		SJServerAddress c = SJServerAddress.create(p, server, port);
		
		SJSocket s = SJFSocket.create(c);
		
		try (s)
		{
			s.request();
			
			s.send("ABC");
			
			m1(null);
		}
		finally
		{
		
		}
	}	
	
	private void m1(String m)
	{
		
	}
	
	public static void main(String[] args) throws Exception
	{
		new Test(args[0], Integer.parseInt(args[1]));
	}
}
