// bin/sjc tests/src/runtime/rsocket/delegation/case1/C.sj -d tests/classes/
// bin/sj -cp tests/classes/ runtime.rsocket.delegation.case1.C 9999

package runtime.fsocket.delegation.case1;

import sj.runtime.*;
import sj.runtime.net.*;

class C 
{
	public static void main(String[] args) throws Exception 
	{
		protocol p_a { ?(int).!<int> }
		protocol p_b { begin.?(@p_a) }

		SJServerSocket ss = null;

		try
		{
			ss = SJRServerSocket.create(p_b, Integer.parseInt(args[0]));
			
			SJSocket s_b = null;		
			SJSocket s_a = null;

			try (s_b, s_a)
			{
				s_b = ss.accept();

				s_a = (@p_a) s_b.receive();			
				
				System.out.println("Received: " + s_a.receiveInt());				
				
				s_a.send(456);
			}
			finally
			{

			}
		}
		finally
		{
			if (ss != null) ss.close();
		}
	}
}
