// bin/sjc tests/src/runtime/rsocket/delegation/case3/D.sj -d tests/classes/
// bin/sj -cp tests/classes/ runtime.rsocket.delegation.case3.D 7777

package runtime.rsocket.delegation.case3;

import java.io.IOException;

import sj.runtime.*;
import sj.runtime.net.*;

class D 
{
	public static void main(String[] args) throws Exception 
	{
		protocol p_a { begin.!<String>.?(String) }

		SJServerSocket ss = null;
		
		try
		{
			ss = SJRServerSocket.create(p_a, Integer.parseInt(args[0]));
		
			SJSocket s_a = null;		

			try (s_a)
			{
				s_a = ss.accept();			
				
				s_a.send("Hello from D!");
				
				System.out.println("Received: " + (String) s_a.receive());
			}
			finally
			{
			
			}
		}
		finally
		{
			ss.close();
		}
	}
}
